
unit CONTROL;
INTERFACE


uses OLVLDATA, CELLS;
type
    ObjectType = record
        data: pointer;
        index: byte;
    end;
    ObjectMatrix = array[1..21, 1..16] of  ^ObjectType;
procedure OUp(var map0: ObjectMatrix; var ld: LevelData);
procedure ODown(var map0: ObjectMatrix; var ld: LevelData);
procedure OLeft(var map0: ObjectMatrix; var ld: LevelData);
procedure ORight(var map0: ObjectMatrix; var ld: LevelData);
IMPLEMENTATION


{ Up -------------------------- }
procedure OUp;
var
    e: ^Empty;
    w: ^Wall;
    p: ^Player;
    b: ^Block;
    g: ^Goal;
    bg: ^BlockX;
    pg: ^PlayerX;
begin
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 2 then
    begin
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 0 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 3 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 4 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 5 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                exit;
            end;
            exit;
        end;
        exit;
    end;
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 6 then
    begin
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 0 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 3 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 4 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY-1]^.index = 5 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY-2]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                exit;
            end;
            exit;
        end;
        exit;
    end;
end;

{ Down ------------------------ }
procedure ODown;
var
    e: ^Empty;
    w: ^Wall;
    p: ^Player;
    b: ^Block;
    g: ^Goal;
    bg: ^BlockX;
    pg: ^PlayerX;
begin
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 2 then
    begin
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 0 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 3 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 4 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 5 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                exit;
            end;
            exit;
        end;
        exit;
    end;
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 6 then
    begin
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 0 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 3 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);

                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 4 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX, ld.GetPositionY+1]^.index = 5 then
        begin
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            if map0[ld.GetPositionX, ld.GetPositionY+2]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY+1);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX, ld.GetPositionY-1);
                exit;
            end;
            exit;
        end;
        exit;
    end;
end;

{ Left ------------------------ }
procedure OLeft;
var
    e: ^Empty;
    w: ^Wall;
    p: ^Player;
    b: ^Block;
    g: ^Goal;
    bg: ^BlockX;
    pg: ^PlayerX;
begin
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 2 then
    begin
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 0 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 3 then
        begin
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                exit;
            end;
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 4 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 5 then
        begin
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                exit;
            end;
            exit;
        end;
        exit;
    end;
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 6 then
    begin
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 0 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 3 then
        begin
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                exit;
            end;
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 4 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX-1, ld.GetPositionY]^.index = 5 then
        begin
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX-2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                exit;
            end;
            exit;
        end;
        exit;
    end;
end;

{ Right ----------------------- }
procedure ORight;
var
    e: ^Empty;
    w: ^Wall;
    p: ^Player;
    b: ^Block;
    g: ^Goal;
    bg: ^BlockX;
    pg: ^PlayerX;
begin
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 2 then
    begin
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 0 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 3 then
        begin
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                exit;
            end;
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 4 then
        begin
                {create Empty-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
            e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            e^.SetX(ld.GetPositionX);
            e^.SetY(ld.GetPositionY);
            e^.Draw;
                {Empty-cell created}
            ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 5 then
        begin
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Empty-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 0;
                e:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                e^.SetX(ld.GetPositionX);
                e^.SetY(ld.GetPositionY);
                e^.Draw;
                    {Empty-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                exit;
            end;
            exit;
        end;
        exit;
    end;
    if map0[ld.GetPositionX, ld.GetPositionY]^.index = 6 then
    begin
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 0 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                {create Player-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
            p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            p^.SetX(ld.GetPositionX);
            p^.SetY(ld.GetPositionY);
            p^.Draw;
                {Player-cell created}
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 3 then
        begin
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                exit;
            end;
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Player-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 2;
                p:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                p^.SetX(ld.GetPositionX);
                p^.SetY(ld.GetPositionY);
                p^.Draw;
                    {Player-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber-1);
                exit;
            end;
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 4 then
        begin
                {create Goal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
            g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            g^.SetX(ld.GetPositionX);
            g^.SetY(ld.GetPositionY);
            g^.Draw;
                {Goal-cell created}
            ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                {create PlayerOnGoal-cell}
            map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
            pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
            pg^.SetX(ld.GetPositionX);
            pg^.SetY(ld.GetPositionY);
            pg^.Draw;
                {PlayerOnGoal-cell created}
            exit;
        end;
        if map0[ld.GetPositionX+1, ld.GetPositionY]^.index = 5 then
        begin
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 0 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create Block-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 3;
                b:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                b^.SetX(ld.GetPositionX);
                b^.SetY(ld.GetPositionY);
                b^.Draw;
                    {Block-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                ld.SetTurgetsNumber(ld.GetTurgetsNumber+1);
                exit;
            end;
            if map0[ld.GetPositionX+2, ld.GetPositionY]^.index = 4 then
            begin
                    {create Goal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 4;
                g:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                g^.SetX(ld.GetPositionX);
                g^.SetY(ld.GetPositionY);
                g^.Draw;
                    {Goal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create PlayerOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 6;
                pg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                pg^.SetX(ld.GetPositionX);
                pg^.SetY(ld.GetPositionY);
                pg^.Draw;
                    {PlayerOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX+1, ld.GetPositionY);
                    {create BlockOnGoal-cell}
                map0[ld.GetPositionX, ld.GetPositionY]^.index:= 5;
                bg:= map0[ld.GetPositionX, ld.GetPositionY]^.data;
                bg^.SetX(ld.GetPositionX);
                bg^.SetY(ld.GetPositionY);
                bg^.Draw;
                    {BlockOnGoal-cell created}
                ld.SetPosition(ld.GetPositionX-1, ld.GetPositionY);
                exit;
            end;
            exit;
        end;
        exit;
    end;
end;

end.
